{% import 'macros/c_connect_fn.j2' as connect_fn %}
{% import 'macros/c_method_fn.j2' as method_fn %}
/*
 * Copyright (C) 2022 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

{% if domain == "trusty_user" %}
#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>
#include <string.h>
{% elif domain == "ql_tipc" %}
#include <trusty/sysdeps.h>
{% endif %}
{% if consts.len(consts.ordered_error_integers) > 0 %}
#include <lib/binder/lk_strerror.h>
{% endif %}

#pragma once

{% for s in consts.ordered_strings %}
#define {{c_impl_name.upper()}}_{{s["name"]}} {{s["value"]}}
{% endfor %}
{{'' if consts.len(consts.ordered_strings) > 0}}
{% for s in consts.ordered_positive_integers %}
#define {{s["name"]}} {{s["value"]}} /* 0x{{ '%08x' % s["value"] | int }} */
{% endfor %}
{{'' if consts.len(consts.ordered_positive_integers) > 0}}
{% for s in consts.ordered_negative_integers %}
#define {{s["name"]}} {{s["value"]}} /* -0x{{ '%08x' % s["value"] | int | abs}} */
{% endfor %}
{{'' if consts.len(consts.ordered_negative_integers) > 0}}

__BEGIN_CDECLS

{{connect_fn.connect_hdr(c_impl_name, impl_name, domain)}}
{% for method in methods %}
{{method_fn.comment(c_impl_name, method)}}
{{method_fn.signature(c_impl_name, method, hdr=true)}};
{{''}}
{{''}}
{%- endfor %}

{% if consts.len(consts.ordered_error_integers) > 0 %}
static __ALWAYS_INLINE char * {{c_impl_name}}_strerror(int errnum) {
    switch (errnum)
    {
{% for err in consts.ordered_error_integers %}
    case {{err.name}}:
        return (char *)"{{err.name}}";
{% endfor %}
    default:
        return lk_strerror(errnum);
    }
}
{% endif %}

__END_CDECLS
